/*
 * Created on 15-giu-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package scuolaTest;

import java.util.GregorianCalendar;

import scuola.*;
import scuola.Exceptions.*;
import junit.framework.TestCase;

/**
 * @author luigi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class TestUseCase extends TestCase {
	
	private Scuola scuola;
	private Segreteria segreteria;
	
	public static void main(String[] args) {
		junit.swingui.TestRunner.run(TestUseCase.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		scuola = new Scuola("Liceo Scientifico Belfiore");
		segreteria = scuola.getSegreteria();
	}
	
    protected void tearDown() throws Exception {
        super.tearDown();
        scuola = null;
        segreteria = null;
    }
	
	public void testAggiungiRimuoviSezione() {
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");
		assertEquals(scuola.numeroDiSezioni(),0);
		
		scuola.aggiungiSezione(pni);
		
		assertEquals(scuola.numeroDiSezioni(),1);

		Sezione bilinguismo = new Sezione("B","Sperimentazione inglese-spagnolo");
		scuola.aggiungiSezione(bilinguismo);
		
		assertEquals(scuola.numeroDiSezioni(),2);
		
		try {
			scuola.aggiungiSezione(bilinguismo);
			fail();
		}
		catch (SezioneDuplicataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			scuola.rimuoviSezione(new Sezione("C","Normale"));
			fail();
		}
		catch (SezioneNonTrovataException e){
			
		}
		catch (RuntimeException e) {
			fail();
		}
				
	}
	
	public void testAggiungiRimuoviClasse() {
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");
		assertEquals(scuola.numeroDiSezioni(),0);
		
		scuola.aggiungiSezione(pni);
		
		Classe primaA = new Classe(1);
		pni.aggiungiClasse(primaA);
		assertEquals(pni.numeroDiClassi(),1);

		Classe secondaA = new Classe(2);
		pni.aggiungiClasse(secondaA);
		assertEquals(pni.numeroDiClassi(),2);
		
		try {
			pni.aggiungiClasse(primaA);
			fail();
		}
		catch (ClasseDuplicataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		pni.rimuoviClasse(1);
		assertEquals(pni.numeroDiClassi(),1);
		
		try {
			pni.rimuoviClasse(1);
			fail();
		}
		catch (ClasseNonTrovataException e){
			
		}
		catch (Exception e) {
			fail();
		}
			
	}
	
	public void testAggiungiRimuoviStudenti() {
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");
		assertEquals(scuola.numeroDiSezioni(),0);
		
		scuola.aggiungiSezione(pni);
		
		Classe primaA = new Classe(1);
		pni.aggiungiClasse(primaA);
		
		GregorianCalendar calendar = new GregorianCalendar(1982,2,22);
		Persona luigi = new Persona("Luigi", "Malag", calendar.getTime(),"124res");
		Persona mario = new Persona("Paolo", "Verdi", calendar.getTime(),"312lkjl");
		Persona paolo = new Persona("Paolo", "Moroni", calendar.getTime(),"uiyf87698");
		Persona anna = new Persona("Anna", "Bianchi", calendar.getTime(),"iuytiu7687659");
		
		Studente sLuigi = segreteria.iscriviStudente(luigi);
		assertEquals(sLuigi.getMatricola(),1);
		Studente sMario = segreteria.iscriviStudente(mario);
		Studente sPaolo = segreteria.iscriviStudente(paolo);
		Studente sAnna = segreteria.iscriviStudente(anna);
		
		assertEquals(segreteria.numeroDiStudenti(),4);
		
		// questi test a differenza di quello che avviene all'interno di una classe
		// mostrano aggiunta e timozioni di studenti non a causa di promozioni a fine anno
		// ma a causa di ritiri a met anno o arrivo di nuovi studenti
		
		primaA.aggiungiStudente(sLuigi);
		assertEquals(primaA,sLuigi.getClasse());
		assertEquals(primaA.numeroDiStudenti(),1);
		primaA.aggiungiStudente(sMario);
		primaA.aggiungiStudente(sPaolo);
		primaA.aggiungiStudente(sAnna);
		assertEquals(primaA.numeroDiStudenti(),4);
		
		try {
			primaA.aggiungiStudente(sLuigi);
			fail();
		}
		catch (StudenteDuplicatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		primaA.rimuoviStudente(sLuigi.getMatricola());
		assertEquals(primaA.numeroDiStudenti(),3);
		
		try {
			primaA.rimuoviStudente(sLuigi.getMatricola());
			fail();
		}
		catch (StudenteNonTrovatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
	}
	
	public void testPromuoviBocciaStudenti() {
		
		// inizializzazione e preparazione degli oggetti
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");

		scuola.aggiungiSezione(pni);
		
		Sezione bilinguismo = new Sezione("B","Sperimentazione inglese-spagnolo");
	
		scuola.aggiungiSezione(bilinguismo);
		
		Classe primaA = new Classe(1);
		pni.aggiungiClasse(primaA);
		Classe secondaA = new Classe(2);
		pni.aggiungiClasse(secondaA);
		
		Classe primaB = new Classe(1);
		bilinguismo.aggiungiClasse(primaB);
		
		Classe quintaB = new Classe(5);
		bilinguismo.aggiungiClasse(quintaB);
		
		GregorianCalendar calendar = new GregorianCalendar(1982,2,22);
		Persona luigi = new Persona("Luigi", "Malag", calendar.getTime(),"124res");
		Persona mario = new Persona("Paolo", "Verdi", calendar.getTime(),"312lkjl");
		Persona paolo = new Persona("Paolo", "Moroni", calendar.getTime(),"uiyf87698");
		Persona anna = new Persona("Anna", "Bianchi", calendar.getTime(),"iuytiu7687659");
		
		Studente sLuigi = segreteria.iscriviStudente(luigi);
		assertEquals(sLuigi.getMatricola(),1);
		Studente sMario = segreteria.iscriviStudente(mario);
		Studente sPaolo = segreteria.iscriviStudente(paolo);
		Studente sAnna = segreteria.iscriviStudente(anna);
		
		assertEquals(segreteria.numeroDiStudenti(),4);
		
		// questi test mostrano le operazioni di bocciatura e di promozione a fine anno
		
		primaA.aggiungiStudente(sLuigi);
		primaA.aggiungiStudente(sMario);
		quintaB.aggiungiStudente(sPaolo);
		primaB.aggiungiStudente(sAnna);
		
		ConsiglioDiClasse consiglio1A = primaA.getConsiglioDiClasse();
		consiglio1A.bocciaStudente(sMario);
		
		assertEquals(primaA.numeroDiStudenti(),2);
		
		consiglio1A.promuoviStudente(sLuigi,secondaA);
		
		assertEquals(primaA.numeroDiStudenti(),1);
		assertEquals(secondaA.numeroDiStudenti(),1);
		
		ConsiglioDiClasse consiglio1B = primaB.getConsiglioDiClasse();
		consiglio1B.bocciaStudente(sAnna,primaA);
		
		assertEquals(primaB.numeroDiStudenti(),0);
		assertEquals(primaA.numeroDiStudenti(),2);
		
		ConsiglioDiClasse consiglio5B = quintaB.getConsiglioDiClasse();
		consiglio5B.diplomaStudente(sPaolo);
		
		assertEquals(quintaB.numeroDiStudenti(),0);
	}
	
	public void testPromuoviBocciaStudentiEccezioni() {
		
		// inizializzazione e preparazione degli oggetti
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");

		scuola.aggiungiSezione(pni);
		
		Sezione bilinguismo = new Sezione("B","Sperimentazione inglese-spagnolo");
	
		scuola.aggiungiSezione(bilinguismo);
		
		Classe primaA = new Classe(1);
		pni.aggiungiClasse(primaA);
		Classe secondaA = new Classe(2);
		pni.aggiungiClasse(secondaA);
		
		Classe primaB = new Classe(1);
		bilinguismo.aggiungiClasse(primaB);
		
		Classe quintaB = new Classe(5);
		bilinguismo.aggiungiClasse(quintaB);
		
		GregorianCalendar calendar = new GregorianCalendar(1982,2,22);
		Persona luigi = new Persona("Luigi", "Malag", calendar.getTime(),"124res");
		Persona mario = new Persona("Paolo", "Verdi", calendar.getTime(),"312lkjl");
		Persona paolo = new Persona("Paolo", "Moroni", calendar.getTime(),"uiyf87698");
		Persona anna = new Persona("Anna", "Bianchi", calendar.getTime(),"iuytiu7687659");
		
		Studente sLuigi = segreteria.iscriviStudente(luigi);
		assertEquals(sLuigi.getMatricola(),1);
		Studente sMario = segreteria.iscriviStudente(mario);
		Studente sPaolo = segreteria.iscriviStudente(paolo);
		Studente sAnna = segreteria.iscriviStudente(anna);
		
		assertEquals(segreteria.numeroDiStudenti(),4);
		
		// questi test mostrano le operazioni di bocciatura e di promozione a fine anno
		
		primaA.aggiungiStudente(sLuigi);
		primaA.aggiungiStudente(sMario);
		quintaB.aggiungiStudente(sPaolo);
		primaB.aggiungiStudente(sAnna);
		
		ConsiglioDiClasse consiglio1A = primaA.getConsiglioDiClasse();
		ConsiglioDiClasse consiglio1B = primaB.getConsiglioDiClasse();
		ConsiglioDiClasse consiglio5B = quintaB.getConsiglioDiClasse();
		
		// questi sono esempi di operazioni non corrette
		
		try {
			consiglio1A.diplomaStudente(sLuigi);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			consiglio1B.promuoviStudente(sLuigi,secondaA);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			consiglio1A.promuoviStudente(sLuigi,primaA);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			consiglio1A.promuoviStudente(sLuigi,quintaB);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			consiglio1A.bocciaStudente(sLuigi,quintaB);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			consiglio5B.bocciaStudente(sAnna);
			fail();
		}
		catch (OperazioneNonConsentitaException e){
			
		}
		catch (Exception e) {
			fail();
		}
	}
	
	public void testProfessoriMaterie() {
		
		GregorianCalendar calendar = new GregorianCalendar(1982,2,22);
		Persona luigi = new Persona("Luigi", "Malag", calendar.getTime(),"124res");
		Persona mario = new Persona("Mario", "Deviolo", calendar.getTime(),"875");
		
		Professore pLuigi = segreteria.assumiProfessore(luigi);
		assertEquals(pLuigi.getMatricola(),1);
		Professore pMario = segreteria.assumiProfessore(mario);;
		
		assertEquals(segreteria.numeroDiProfessori(),2);
		
		Materia italiano = new Materia("italiano","letteratura italiana");
		Materia inglese = new Materia("inglese","letteratura inglese");
		Materia matematica = new Materia("matematica","calcolo numerico");
		
		pLuigi.aggiungiMateria(italiano);
		assertEquals(pLuigi.numeroDiMaterie(),1);
		pLuigi.aggiungiMateria(matematica);
		assertEquals(pLuigi.numeroDiMaterie(),2);
		assertEquals(matematica.numeroDiProfessori(),1);
		matematica.rimuoviProfessore(pLuigi);
		assertEquals(matematica.numeroDiProfessori(),0);
		assertEquals(pLuigi.numeroDiMaterie(),1);
		
		try {
			pLuigi.aggiungiMateria(italiano);
			fail();
		}
		catch (MateriaDuplicataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			pLuigi.rimuoviMateria(new Materia("francese","letteratura francese"));
			fail();
		}
		catch (MateriaNonTrovataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			italiano.aggiungiProfessore(pLuigi);
			fail();
		}
		catch (ProfessoreDuplicatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			matematica.rimuoviProfessore(pLuigi);
			fail();
		}
		catch (ProfessoreNonTrovatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
	}
	
	public void testProfessoriClassi() {
		
		//inizializzazione e preparazione degli oggetti
		
		GregorianCalendar calendar = new GregorianCalendar(1982,2,22);
		Persona luigi = new Persona("Luigi", "Malag", calendar.getTime(),"124res");
		Persona mario = new Persona("Mario", "Deviolo", calendar.getTime(),"875"); 
		Persona paolo = new Persona("Paolo", "Deva", calendar.getTime(),"875qqq");
		
		Professore pLuigi = segreteria.assumiProfessore(luigi);
		Professore pMario = segreteria.assumiProfessore(mario);
		Professore pPaolo = segreteria.assumiProfessore(paolo);
		try {
			pPaolo = segreteria.assumiProfessore(paolo);
			fail();
		}
		catch (ProfessoreDuplicatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		
		Sezione pni = new Sezione("A","Piano nazionale informatico");
		scuola.aggiungiSezione(pni);
		
		Classe primaA = new Classe(1);
		pni.aggiungiClasse(primaA);
		Classe secondaA = new Classe(2);
		pni.aggiungiClasse(secondaA);
		
		// esempi di aggiunta e rimozione di professori da classi sia invocando il metodo
		// aggiungiClasse() di un professore che aggiungiProfessore() di una classe
		
		assertEquals(pPaolo.numeroDiClassi(),0);
		pPaolo.aggiungiClasse(primaA);
		assertEquals(pPaolo.numeroDiClassi(),1);
		assertEquals(primaA.numeroDiProfessori(),1);
		secondaA.aggiungiProfessore(pPaolo);
		secondaA.aggiungiProfessore(pLuigi);
		assertEquals(pPaolo.numeroDiClassi(),2);
		assertEquals(secondaA.numeroDiProfessori(),2);
		secondaA.aggiungiProfessore(pMario);
		secondaA.rimuoviProfessore(pMario);
		assertEquals(secondaA.numeroDiProfessori(),2);
		assertEquals(pMario.numeroDiClassi(),0);
		pPaolo.rimuoviClasse(primaA);
		assertEquals(primaA.numeroDiProfessori(),0);
		assertEquals(pPaolo.numeroDiClassi(),1);
		
		// esempi che lanciano eccezioni
		
		try {
			pLuigi.aggiungiClasse(secondaA);
			fail();
		}
		catch (ClasseDuplicataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			pLuigi.rimuoviClasse(new Classe(2));
			fail();
		}
		catch (ClasseNonTrovataException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			secondaA.aggiungiProfessore(pLuigi);
			fail();
		}
		catch (ProfessoreDuplicatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
		
		try {
			secondaA.rimuoviProfessore(pMario);
			fail();
		}
		catch (ProfessoreNonTrovatoException e){
			
		}
		catch (Exception e) {
			fail();
		}
	}
}
